import com.alibaba.fastjson.JSON;
import mapper.AccountPayMapper;
import model.AccountPay;
import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;

import java.io.*;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

/**
 * Created by Yang.jing on 18/8/8.
 */
public class DataRemainUtil {

    private static AccountPayMapper accountPayMapper;

    public static void main(String[] args) throws IOException {
        InputStream inputStream = Resources.getResourceAsStream("mybatis-config.xml");

//        构件sqlSession工厂
        SqlSessionFactory sqlSessionFactory = new SqlSessionFactoryBuilder().build(inputStream);
        SqlSession sqlSession = sqlSessionFactory.openSession(true);

        accountPayMapper = sqlSession.getMapper(AccountPayMapper.class);

//        AccountPay accountPay = accountPayMapper.getAccount("1249781701", "2018080622-00061001823319");
//        System.out.println(JSON.toJSONString(accountPay));
        processLogBr("/Users/yangjing/Documents/米雅文档/回插数据/1-16.log");
//        processLogBr("/Users/yangjing/Documents/米雅文档/回插数据/8-8-utf.log");
    }

    public static void processLog(String path) throws IOException {
        File logFile = new File(path);

        InputStream is = new FileInputStream(logFile);
        StringBuilder sb = new StringBuilder();

        byte[] b = new byte[1024];

        int len = 0;
        int temp = 0;            // 接收每一个读取进来的数据
        while ((temp = is.read(b)) != -1) {
            if(temp < b.length){
                byte[] target = new byte[temp];
                System.arraycopy(b, 0, target, 0, temp);
                sb.append(new String(target));
            }else {
                sb.append(new String(b));
            }
            len+= temp;
        }

        System.out.println(sb.toString());

    }

    public static void processLogBr(String path) throws IOException {
        List<String> logList = getLogList(path);
        List<AccountPay> accountPayList = new LinkedList<AccountPay>();

        logList.forEach(log -> {
            int startIndex = log.indexOf("保存异常,");
            int endIndex = log.indexOf(",原因:");
            String data = log.substring(startIndex + 5, endIndex);
            AccountPay accountPay = new AccountPay();
            try{
                accountPay = JSON.parseObject(data, AccountPay.class);
            }catch (Exception e){
                System.out.println("JSON parseError : " + log);
                return ;
            }
            try{
                int row = accountPayMapper.insertAccount(accountPay);
                if(row < 1){
                    System.out.println(row + " saasid : " + accountPay.getSaasid() + ", outid: " + accountPay.getOutId());
                    System.out.println("error log : " + log);
                }
            }catch (Exception e){
                System.out.println(e.getMessage());
                System.out.println("error log : " + log);
                System.out.println("error: saasid : " + accountPay.getSaasid() + ", outid: " + accountPay.getOutId());
            }
            accountPayList.add(accountPay);
        });

        System.out.println("日志总条数: " + accountPayList.size());

    }

    private static List<String> getLogList(String path) throws IOException{
        File logFile = new File(path);

        BufferedReader br = new BufferedReader(new FileReader(logFile));

        List<String> logList = new ArrayList<String>(200);
        String temp = "";

        while ((temp = br.readLine()) != null) {
            logList.add(temp);
        }

        return logList;
    }
}
